import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Bolt here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Bolt extends Actor
{
    
    int lifespan = 0;
    int speedX = 0;
    int speedY = 0;
    
    int currentX;
    int currentY;
    
    boolean detectNextFrame = false;
    public Bolt(int lifespan, int speedX, int speedY){
        this.lifespan = lifespan;
        this.speedX = speedX * 3;
        this.speedY = speedY * 3;
        
        this.getImage().scale((int)(getImage().getWidth() / 2.5), (int)(getImage().getHeight() / 2.5));
    }
    
    /**
     * Act - do whatever the Bolt wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!this.isTouching(Wall.class)){
            currentX = this.getX();
            currentY = this.getY();
        }
        
        move();
        detectWall();
        detectHit();
        decay();
        destroy();
        
    }    
    
    public void move(){
        int x = getWorld().getWidth();
        int y = getWorld().getHeight();
        
        int x2 = this.getX();
        int y2 = this.getY();
        
        if(x2 >= x - 5 || x2 <= 5){
            speedX *= -1;
        }
        if(y2 >= y - 5 || y2 <= 5){
            speedY *= -1;
        }
        
        this.setLocation(x2 + speedX, y2 + speedY);
    }
    
    public void decay(){
        lifespan--;
        
        
    }
    
    public void detectHit(){
        
        if(this.isTouching(Enemy.class)){
                Enemy enemy = (Enemy)this.getOneIntersectingObject(Enemy.class);
                if(enemy.getInvincibility() <= 0){
                    enemy.loseHealth(this);
                    this.getWorld().removeObject(this);
                }
        }else if(this.isTouching(randomEnemy.class)){
                randomEnemy enemy = (randomEnemy)this.getOneIntersectingObject(randomEnemy.class);
                if(enemy.getInvincibility() <= 0){
                    enemy.loseHealth(this);
                    this.getWorld().removeObject(this);
                }
        }else if(this.isTouching(Copyrighted.class)){
                Copyrighted copyright = (Copyrighted)this.getOneIntersectingObject(Copyrighted.class);
                if(copyright.getInvincibility() <= 0){
                    copyright.loseHealth();
                    this.getWorld().removeObject(this);
                }
        }
    
    }
    
    public void detectWall(){
        if(this.isTouching(Wall.class)){
            speedX *= -1;
            detectNextFrame = true;
            
            Wall wall = (Wall)this.getOneIntersectingObject(Wall.class);
            this.turnTowards(wall.getX(), wall.getY());
            
            
            if(detectNextFrame){
                speedY *= -1;
                
                detectNextFrame = false;
            }
            this.setLocation(currentX, currentY);
            
        }else{
            detectNextFrame = false;
        }
    }
    
    public void destroy(){
        if(lifespan <= 0){
            this.getWorld().removeObject(this);
        }
    }
}
