import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Player here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Player extends Actor
{
    int lastPlayerX = 0;
    int lastPlayerY = 0;
    
    int currentPlayerX = 0;
    int currentPlayerY = 0;
    
    int swordSwing = 0;
    
    Sword sword;
    
    boolean allowMovement = true;
    boolean allowMovement2 = true;
    boolean swinging = false;
    boolean allowSwing = true;
    
    int hp = 0;
    int invincibility = 0;
    
    int score;
    int targetScore;
    
    int count = 0;
    
    int frames = 10;
    
    int delay = 0;
    int knockback = 0;
    double kbDis = 7.0;
    
    int rot = 0;
    double round90 = 0;
    
    int bolts = 0;
    
    World currentWorld;
    
    int level;
    
    boolean allowBolt = true;
    
    int timer;
    public Player(Sword sword, int hp, int bolts, World currentWorld, int targetScore, int level){
        this.getImage().scale((int)(this.getImage().getWidth() * (0.8)), (int)(this.getImage().getHeight() * (0.8)));
        this.sword = sword;
        
        this.score = 0;
        this.targetScore = targetScore;
        
        this.bolts = bolts;
        this.hp = hp;
        this.currentWorld = currentWorld;
        
        this.level = level;
        
        timer = 300 * 60;
    }
    
    /**
     * Act - do whatever the Player wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(!this.isTouching(Wall.class)){
            currentPlayerX = this.getX();
            currentPlayerY = this.getY();
        }
        
        if(allowMovement && allowMovement2){
            movement();
        }
        
        slash();
        showStatus();
        
        if(invincibility <= 0){
            detectEnemy();
        }else{
            invincibility--;
        }
        lastPlayerX = this.getX();
        lastPlayerY = this.getY();
        
        if(knockback > 0){
            allowMovement2 = false;
            if(delay >= 2){
                knockback--;
                this.setRotation(rot);
                delay = 0;
                knockback((int)kbDis);
                kbDis -= 0.7;
            }else{
                delay++;
                this.setRotation((int)round90);
            }
        }else{
            kbDis = 7.0;
            delay = 0;
            if(!allowMovement2){
                this.setRotation((int)round90);
            }
            allowMovement2 = true;
            
        }
        
        detectWall();
        
        screenWrap();
        timer();
        
        restart();
    }
    
    public void movement(){
        int moveX = 0;
        int moveY = 0;
        
        if(Greenfoot.isKeyDown("a") || Greenfoot.isKeyDown("left")){
            moveX = -1;
            setRotation(90);
        }
        if(Greenfoot.isKeyDown("d") || Greenfoot.isKeyDown("right")){
            moveX = 1;
            setRotation(270);
        }
        if(Greenfoot.isKeyDown("s") || Greenfoot.isKeyDown("down")){
            moveY = 1;
            setRotation(0);
        }
        if(Greenfoot.isKeyDown("w") || Greenfoot.isKeyDown("up")){
            moveY = -1;
            setRotation(180);
        }
        
        this.setLocation(currentPlayerX + moveX, currentPlayerY + moveY);
        
        if(Greenfoot.isKeyDown("x") && bolts > 0 && allowBolt){
            shootBolt(moveX, moveY);
            allowBolt = false;
        }
        
        if(!Greenfoot.isKeyDown("x")){
            allowBolt = true;
        }
    }
    public void shootBolt(int speedX, int speedY){
        Bolt bolt = new Bolt(300, speedX, speedY);
        currentWorld.addObject(bolt, this.getX(), this.getY());
        bolts--;
    }
    
    public void slash(){
       
       if(count > 0){
           count--;
       }
       if(Greenfoot.isKeyDown("z") && !swinging && count == 0){
           this.sword.turn(112);
           placeSwordSwing();
           swordSwing = 0;
           swing();
           count = 60;
       }else if(swinging){
           swingSword();
       }else{
           placeSword();
           allowMovement = true;
       }
    
    }
    
    public void placeSword(){
        if(this.getRotation() == 0){
                sword.setRotation(0);
                sword.setLocation(this.getX() + this.getImage().getWidth() / 2, this.getY() - this.getImage().getWidth() / 2);
        }
        if(this.getRotation() == 90){
                sword.setRotation(90);
                sword.setLocation(this.getX() + this.getImage().getHeight() / 2, this.getY() + this.getImage().getHeight() / 2);
        }
        if(this.getRotation() == 180){
                sword.setRotation(180);
                sword.setLocation(this.getX() - this.getImage().getWidth() / 2, this.getY() + this.getImage().getWidth() / 2);
        }
        if(this.getRotation() == 270){
                sword.setRotation(270);
                sword.setLocation(this.getX() - this.getImage().getHeight() / 2, this.getY() - this.getImage().getHeight() / 2);
        }
    }
    
    public void swing(){
        swinging = true;
        allowMovement = false;
        sword.swing();
        
    }
    
    public void placeSwordSwing(){
        if(this.getRotation() == 0){
                //sword.setRotation(0);
                sword.setLocation(this.getX(), this.getY() + this.getImage().getWidth() / 4);
        }
        if(this.getRotation() == 90){
                //sword.setRotation(90);
                sword.setLocation(this.getX() - this.getImage().getHeight() / 4, this.getY());
        }
        if(this.getRotation() == 180){
                //sword.setRotation(180);
                sword.setLocation(this.getX(), this.getY() - this.getImage().getWidth() / 4);
        }
        if(this.getRotation() == 270){
                //sword.setRotation(270);
                sword.setLocation(this.getX() + this.getImage().getHeight() / 4, this.getY());
        }
    }
    
    public void swingSword(){
        if(swordSwing < 135){
            sword.turn(5);
            swordSwing += 5;
        }else{
            swinging = false;
            sword.revert();
        }
    }
    
    public void detectEnemy(){
        if(this.isTouching(Enemy.class)){
            hp--;
            invincibility = 150;
            knockback = 10;
            detectEnd();
            
            Enemy en = (Enemy)this.getOneIntersectingObject(Enemy.class);
            
            this.turnTowards(en.getX(), en.getY());
            
            rot = this.getRotation();
            round90 = rot / 4;
            round90 = Math.round(round90) * 90;
        }else if(this.isTouching(randomEnemy.class)){
            hp--;
            invincibility = 150;
            knockback = 10;
            detectEnd();
            
            randomEnemy en = (randomEnemy)this.getOneIntersectingObject(randomEnemy.class);
            
            this.turnTowards(en.getX(), en.getY());
            
            rot = this.getRotation();
            round90 = rot / 4;
            round90 = Math.round(round90) * 90;
        }else if(this.isTouching(Copyrighted.class)){
            hp--;
            invincibility = 150;
            knockback = 10;
            detectEnd();
            
            Copyrighted en = (Copyrighted)this.getOneIntersectingObject(Copyrighted.class);
            
            this.turnTowards(en.getX(), en.getY());
            
            rot = this.getRotation();
            round90 = rot / 4;
            round90 = Math.round(round90) * 90;
        }
        
    }
    
    public void knockback(int dis){
        
        this.move(dis * -1);
        
    }
    public void timer(){
        timer--;
        detectTime();
    }
    
    public void detectTime(){
        if(timer <= 0){
            this.getWorld().showText("Time ran out", this.getWorld().getWidth() / 2, this.getWorld().getHeight() / 2);
        }
    }
    
    public void detectEnd(){
        if(hp <= 0){
            this.getWorld().showText("HP : " + hp, 64, this.getWorld().getHeight() - 64);
            this.getWorld().showText("GAME OVER", this.getWorld().getWidth() / 2, this.getWorld().getHeight() / 2);
            Greenfoot.stop();
        }
    }
    public void showStatus(){
        this.getWorld().showText("HP : " + hp, 92, this.getWorld().getHeight() - 64);
        this.getWorld().showText("Bolts : " + bolts, 92, this.getWorld().getHeight() - 48);
        this.getWorld().showText("Score : " + score, 92, this.getWorld().getHeight() - 32);
        this.getWorld().showText("Time Left : " + new Integer(timer / 60), 92, this.getWorld().getHeight() - 16);
        
    }
    
    public void screenWrap(){
        int x = this.getX();
        int y = this.getY();
        int w = this.getWorld().getWidth();
        int h = this.getWorld().getHeight();
         
        
        if(x >= w - 1){
            this.setLocation(3, y);
        }
        if(x <= 2){
            this.setLocation(w - 2, y);
        }
        if(y >= h - 1){
            this.setLocation(x, 3);
        }
        if(y <= 2){
            this.setLocation(x, h - 2);
        }
    
    }
    
    public void detectWall(){
        if(this.isTouching(Wall.class)){
            this.setLocation(currentPlayerX, currentPlayerY);
        }
    }
    
    public void increaseScore(){
        this.score++;
        detectWin();
        
        if(level == 2 && score == 5){
            addEnemies();
        }
    }
    
    public void addEnemies(){
        int w = currentWorld.getWidth();
        int h = currentWorld.getHeight();
        currentWorld.addObject(new randomEnemy(5, this), w / 2, h / 2);
        currentWorld.addObject(new Enemy(7, this), w / 2, (h / 2) + 128);
        currentWorld.addObject(new Enemy(7, this), w / 2, (h / 2) - 128);
    }
    
    public void detectWin(){
        if(score == targetScore){
            currentWorld.addObject(new Door(level), getWorld().getWidth() / 2, getWorld().getHeight() / 2);
        }
    }
    
    public void restart(){
        if(Greenfoot.isKeyDown("E")){
            Greenfoot.setWorld(new Menu());
        }
        
        if(Greenfoot.isKeyDown("R")){
            restartLevel();
        }
    }
    
    public void restartLevel(){
        if(this.level == 1){
            Greenfoot.setWorld(new Level1());
        }
        if(this.level == 2){
            Greenfoot.setWorld(new Level2());
        }
        if(this.level == 3){
            Greenfoot.setWorld(new Level1());
        }
    }
}
